# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::NetApp::Mgmt::V2020_09_01
  module Models
    #
    # Volume Export Policy Rule
    #
    class ExportPolicyRule

      include MsRestAzure

      # @return [Integer] Order index
      attr_accessor :rule_index

      # @return [Boolean] Read only access
      attr_accessor :unix_read_only

      # @return [Boolean] Read and write access
      attr_accessor :unix_read_write

      # @return [Boolean] Kerberos5 Read only access. To be use with swagger
      # version 2020-05-01 or later. Default value: false .
      attr_accessor :kerberos5read_only

      # @return [Boolean] Kerberos5 Read and write access. To be use with
      # swagger version 2020-05-01 or later. Default value: false .
      attr_accessor :kerberos5read_write

      # @return [Boolean] Kerberos5i Read only access. To be use with swagger
      # version 2020-05-01 or later. Default value: false .
      attr_accessor :kerberos5i_read_only

      # @return [Boolean] Kerberos5i Read and write access. To be use with
      # swagger version 2020-05-01 or later. Default value: false .
      attr_accessor :kerberos5i_read_write

      # @return [Boolean] Kerberos5p Read only access. To be use with swagger
      # version 2020-05-01 or later. Default value: false .
      attr_accessor :kerberos5p_read_only

      # @return [Boolean] Kerberos5p Read and write access. To be use with
      # swagger version 2020-05-01 or later. Default value: false .
      attr_accessor :kerberos5p_read_write

      # @return [Boolean] Allows CIFS protocol
      attr_accessor :cifs

      # @return [Boolean] Allows NFSv3 protocol. Enable only for NFSv3 type
      # volumes
      attr_accessor :nfsv3

      # @return [Boolean] Allows NFSv4.1 protocol. Enable only for NFSv4.1 type
      # volumes
      attr_accessor :nfsv41

      # @return [String] Client ingress specification as comma separated string
      # with IPv4 CIDRs, IPv4 host addresses and host names
      attr_accessor :allowed_clients

      # @return [Boolean] Has root access to volume. Default value: true .
      attr_accessor :has_root_access


      #
      # Mapper for ExportPolicyRule class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'exportPolicyRule',
          type: {
            name: 'Composite',
            class_name: 'ExportPolicyRule',
            model_properties: {
              rule_index: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ruleIndex',
                type: {
                  name: 'Number'
                }
              },
              unix_read_only: {
                client_side_validation: true,
                required: false,
                serialized_name: 'unixReadOnly',
                type: {
                  name: 'Boolean'
                }
              },
              unix_read_write: {
                client_side_validation: true,
                required: false,
                serialized_name: 'unixReadWrite',
                type: {
                  name: 'Boolean'
                }
              },
              kerberos5read_only: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kerberos5ReadOnly',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              kerberos5read_write: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kerberos5ReadWrite',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              kerberos5i_read_only: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kerberos5iReadOnly',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              kerberos5i_read_write: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kerberos5iReadWrite',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              kerberos5p_read_only: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kerberos5pReadOnly',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              kerberos5p_read_write: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kerberos5pReadWrite',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              cifs: {
                client_side_validation: true,
                required: false,
                serialized_name: 'cifs',
                type: {
                  name: 'Boolean'
                }
              },
              nfsv3: {
                client_side_validation: true,
                required: false,
                serialized_name: 'nfsv3',
                type: {
                  name: 'Boolean'
                }
              },
              nfsv41: {
                client_side_validation: true,
                required: false,
                serialized_name: 'nfsv41',
                type: {
                  name: 'Boolean'
                }
              },
              allowed_clients: {
                client_side_validation: true,
                required: false,
                serialized_name: 'allowedClients',
                type: {
                  name: 'String'
                }
              },
              has_root_access: {
                client_side_validation: true,
                required: false,
                serialized_name: 'hasRootAccess',
                default_value: true,
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
