# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::NetApp::Mgmt::V2020_11_01
  module Models
    #
    # Metadata pertaining to creation and last modification of the resource.
    #
    class SystemData

      include MsRestAzure

      # @return [String] The identity that created the resource.
      attr_accessor :created_by

      # @return [CreatedByType] The type of identity that created the resource.
      # Possible values include: 'User', 'Application', 'ManagedIdentity',
      # 'Key'
      attr_accessor :created_by_type

      # @return [DateTime] The timestamp of resource creation (UTC).
      attr_accessor :created_at

      # @return [String] The identity that last modified the resource.
      attr_accessor :last_modified_by

      # @return [CreatedByType] The type of identity that last modified the
      # resource. Possible values include: 'User', 'Application',
      # 'ManagedIdentity', 'Key'
      attr_accessor :last_modified_by_type

      # @return [DateTime] The timestamp of resource last modification (UTC)
      attr_accessor :last_modified_at


      #
      # Mapper for SystemData class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'systemData',
          type: {
            name: 'Composite',
            class_name: 'SystemData',
            model_properties: {
              created_by: {
                client_side_validation: true,
                required: false,
                serialized_name: 'createdBy',
                type: {
                  name: 'String'
                }
              },
              created_by_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'createdByType',
                type: {
                  name: 'String'
                }
              },
              created_at: {
                client_side_validation: true,
                required: false,
                serialized_name: 'createdAt',
                type: {
                  name: 'DateTime'
                }
              },
              last_modified_by: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastModifiedBy',
                type: {
                  name: 'String'
                }
              },
              last_modified_by_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastModifiedByType',
                type: {
                  name: 'String'
                }
              },
              last_modified_at: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastModifiedAt',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
